import registerSystem from "../../../register/registerSystem.js";

export default class titleUI extends registerSystem {
    constructor(target) {
        super();
        this.player = target;
        this.json_text = (ui) => {
            return JSON.stringify({rawtext:[{text:ui}]});
        }
    }
    loadingUI(ui) {
        this.runCommand(`titleraw @s title ${this.json_text(ui)}`, this.player);
    }
    loadingUI2(ui) {
        this.runCommand(`title @s subtitle ${ui}`, this.player);
    }
    loadingUI3(ui,effect_ui = undefined) {
        // this.runCommand(`title @s title ${ui}`, this.player);
        if (effect_ui !== undefined) {
            this.player?.onScreenDisplay.setTitle(ui,{subtitle:effect_ui});
        } else {
            this.player?.onScreenDisplay.setTitle(ui);
        }
    }
    loadingGUI(data) {
        // let i = 0;
        
        let { name, value } = data;
        let array = value.map(v => {
            /*
            let skills_value = () => {
                if (typeof v === "number") {
                    return {
                        text: "",
                        number: v.toFixed(1),
                        all: function() {
                            return this.text + this.number;
                        }
                    }
                }
                if (v.includes("#")) {
                    return {
                        text1: v.split("#")[0],
                        text2: v.split("#")[2] !== undefined ? v.split("#")[2] : "",
                        number: parseFloat(v.split("#")[1]).toFixed(1),
                        all: function() {
                            return this.text1 + this.number + this.text2;
                        }
                    }
                }
            }
            return skills_value().number < 0.5 ? "§4" + skills_value().all() + "§r" : skills_value().all() + "§r";*/
            return v + "§r"
            
            
        }).join("\n\n\n");
        let color = {
            x: "§b",
            y: "§a",
            z: "§c"
        }
        let xyz = (key) => {
            return "txyz".split("").map(p => {
                if (p == "t") {
                    return "§l" + key + "§r: "
                } else {
                    if (key === "getLocation") {
                        return color[p] + this.player["location"][p].toFixed(2) + "§r";
                    } else {
                        return color[p] + this.player[key]()[p].toFixed(2) + "§r";
                    }
                }
            }).join(" ")
        }
        let xy = (key) => {
            return "txy".split("").map(p => {
                if (p == "t") {
                    return "§l" + key + "§r: "
                } else {
                    return color[p] + this.player[key]()[p].toFixed(2) + "§r";
                }
            }).join(" ")
        }
        let debug_text = this.player.name === "DustEndersWT" ? [
            `§r\n§e[debug]§r\n`,
            `${xyz("getVelocity")}\n`,
            `${xyz("getViewDirection")}\n`,
            `${xyz("getLocation")}\n`,
            `${xyz("getHeadLocation")}\n`,
            `${xy("getRotation")}\n`,
            // `§ldirectionAngle§r: §b${(Math.atan2(this.player?.velocity.x,this.player?.velocity.z) * 180 / Math.PI).toFixed(2)}§r\n`,
            // `§lfps§r: §b${this.GlobalVar(this.player,"fps").var}§r`
            `§lversion: §b1.1.0§r`
        ] : [
            "\n"
        ]
        
        let list = [
            "@gui-" + name,
            this.GlobalVar(this.player,"line_wrap").var,
            ...debug_text,
            this.GlobalVar(this.player,"line_wrap").var,
            ...array
        ]
        let text = list.join("");
        this.player?.onScreenDisplay.setActionBar(text)
    }
}