import range from '../../../../modules/arrayRange.js';
import Mathf from '../../../../modules/Mathf.js';


import standPower from '../../default/standPower.js';



new standPower("goldExperience").register(data => {
    data.skills_count = 2;
    
    data.LoadingGUI({
        name: "standCode:B",
        value: [
            data.fist_duration.var / 20,
            data.create_life_cd.var / 20,
            data.cure_cd.var / 20,
            "§r#" + data.projectile_iGL.var
        ]
    });
    
    data.summon({
        anim_id: "gold_experience",
        sounds: [
            "goldExperience.name"
        ]
    });
    
    data.quickFist({
        range: 4,
        damage: 3,
        duration: 3,
        fist_sounds: [
            "goldExperience.quick_fist1->2",
            "goldExperience.muda->58"
        ],
        hit_sounds: [
            "goldExperience.muda_loud->38"
        ],
        mental: {
            value: 1,
            interval: Math.floor(Mathf.random(40,60))
        }
    });
    
    data.createLife({
        range: 4,
        duration: 4,
        count: data.createdEntity.var == "goldexperience:spider" ? Math.floor(Mathf.random(1,3)) : Math.floor(Mathf.random(3,6)),
        mental: Math.floor(Mathf.random(3,5))
    });
    
    data.cureSelf({
        duration: 1,
        value: Math.floor(Mathf.random(5,8)),
        mental: 3
    });
    
})

