import range from '../../../../modules/arrayRange.js';
import Mathf from '../../../../modules/Mathf.js';


import standPower from '../../default/standPower.js';

new standPower("kingCrimson").register(data => {
    let erase_cooldown = 3;
    
    data.skills_count = 2;
    
    data.LoadingGUI({
        name: "standCode:D",
        value: [
            data.fist_duration.var / 20,
            data.ap_cd.var / 20,
            (data.standMaster.hasTag("kingCrimson.epitaph") ? "§e#" : "#") + data.epitaph_tick.var / 20,
            "§r#" + data.erase_tick.var / 20 + "#" + (data.standMaster.hasTag("kc.erase_cooldown") ? ` | §b${(erase_cooldown - data.erase_tick2.var / 20).toFixed(1)}§r` : "§r")
        ]
    });
    
    data.epitaph({
        duration: 4,
        mental: {
            value: Math.floor(Mathf.random(1,3)),
            interval: 40
        }
    });
    
    data.timeErase({
        duration: 10,
        cooldown: erase_cooldown,
        mental: 5
    });
    
    data.summon({
        anim_id: "king_crimson",
        sounds: [
            "kingCrimson.name"
        ]
    });
    data.quickFist({
        range: 4,
        damage: 5,
        duration: 1.5,
        fist_sounds: [
            "kingCrimson.quick_fist->2"
        ],
        hit_sounds: [
            "kingCrimson.quick_fist->20"
        ],
        mental: {
            value: 1,
            interval: Math.floor(Mathf.random(20,30))
        }
    });
    data.APattack({
        range: 4,
        damage: 20,
        cooldown: 3,
        mental: 1
    });
    
})

