import range from "../../modules/arrayRange.js";
import registerSystem from "../../register/registerSystem.js";
import * as mc from "@minecraft/server";

let initialTime = 0;


class FPS extends registerSystem {
    constructor() {
        super();
        this.listenForEvent("minecraft:beforeWatchdogTerminate", (eventData) => {
            eventData.cancel = true;
        })
        this.tick(() => this.update(), 20);
    }
    
    scoresCreate() {
        let globalScores = this.scoresStatic();
        globalScores.create(
            "FPS"
        );
        globalScores.setdisplay(
            "FPS/sidebar/ascending"
        );
    }
    
    update(eventData) {
        
        
        this.getPlayers().forEach(player => {
            let tick = this.GlobalVar(player,"tick");
            let fps_tick = this.GlobalVar(player,"fps_tick");
            let fps = this.GlobalVar(player,"fps");
            let delta_time = this.GlobalVar(player,"delta_time");
            
            let clear_items = this.GlobalVar(mc.world,"clear_items");
            let clear_tnts = this.GlobalVar(mc.world,"clear_tnts");
            
            
            // fps_tick.var += 1;
            if (fps.var >= 0) {
                const tickTime = new Date().getTime();
                initialTime = tickTime;
                delta_time.var = (tickTime - initialTime) / 1000;
                fps.var = 1 / delta_time.var;
                console.error(delta_time.var)
                
                // let fpsUI = this.scores(player, "FPS");
                // fpsUI.var = fps.var;
                // this.runCommand(`say ${fps.var}`, player);
                
                // fps_tick.var = 0;
            }
            if (fps.var < 30) {
                if (clear_tnts.var) {
                    this.getEntities({type:"tnt"}).forEach(entity => {
                        entity.kill();
                    })
                }
                if (clear_items.var) {
                    this.getEntities({type:"item"}).forEach(entity => {
                        entity.kill();
                    })
                }
                
            }
            
        })
        
    }

}

const system = new FPS();
